//differences in code from vb6:
//broke code into sections so drawing is in correct area and every moving object has its own code block.
//
//no longer using different images for each angle.  xna makes rotation easy.
using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Wormipede_xna
{
    public struct TrailSpot
    {
       public int Dir;
       public int X;
       public int Y;
    }
    public struct MyRect
    {
        public int Top;
        public int Left;
        public int Width;
        public int Height;
    }
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        GraphicsDevice device;
        
        bool GameEnded = false;
   
        int[,] ItemGrid = new int[57, 51];
        int FoodOnBoard;
        int AddToTail;
        //'click variables
        int XPos;
        int YPos;

        int OffsetLoop;
        Rectangle[,] ScreenGrid = new Rectangle[57, 51];//Set up in SetUpScreenGrid()
        TrailSpot[] trail = new TrailSpot[2801];
        Point Direction;
        int TrailLength;
        int TrailHeadPos;
        TrailSpot HeadPos;

        
        int SpiderX;
        int SpiderY;
        int SpiderXGoal;
        int SpiderYGoal;
        bool SpiderAttack;
        int SpiderXSpeed;
        int SpiderYSpeed;
        bool SpiderVisible;
        bool SpiderDeath;
        int TickX;
        int TickY;
        bool TickInAction;

    

        Texture2D BackgroundTexture;
        Texture2D BodyTexture;
        Texture2D GameOverTexture;
        Texture2D HeadTexture;
        Texture2D PausedTexture;
        Texture2D SpiderTexture;
        Texture2D TailTexture;
        Texture2D TickTexture;
        Texture2D WebTexture;
        Texture2D MushroomTexture;

        AudioEngine audioEngine;
        WaveBank waveBank;
        SoundBank soundBank;

        SpriteFont Font;
        int screenWidth;
        int screenHeight;

        bool NowPlaying;
        bool Paused;
         int CurrentScore;
        int HighScore;
        int Level;
        int YY;

        bool NewDir;
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            graphics.PreferredBackBufferWidth = 800;
            graphics.PreferredBackBufferHeight = 600;
            graphics.IsFullScreen = false;
            graphics.ApplyChanges();
            Window.Title = "Wormipede XNA";
            this.IsMouseVisible = true;
            base.Initialize();
            NewGame();
            Init();
        }
        private void SetUpScreenGrid()
        {
            int x; int y;
            for (x = 1; x <= 56; x++)
            {
                for (y = 1; y <= 50; y++)
                {
                    ScreenGrid[x, y] = new Rectangle(x * 10 + 193 - 10, y * 10 + 51 - 10, 10, 10);
                }
            }
            
           }
        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            device = graphics.GraphicsDevice;
           
            BackgroundTexture = Content.Load<Texture2D>("Background");
            BodyTexture = Content.Load<Texture2D>("BodyNorth");
            GameOverTexture = Content.Load<Texture2D>("gameover");
            HeadTexture = Content.Load<Texture2D>("HeadNorth");
            MushroomTexture = Content.Load<Texture2D>("mushroom");
            PausedTexture = Content.Load<Texture2D>("paused");
            SpiderTexture = Content.Load<Texture2D>("spider");
            TailTexture = Content.Load<Texture2D>("TailNorth");
            TickTexture = Content.Load<Texture2D>("tick");
            WebTexture = Content.Load<Texture2D>("web");

            audioEngine = new AudioEngine("Content/WormipedeSounds.xgs");
            waveBank = new WaveBank(audioEngine, "Content/myWaveBank.xwb");
            soundBank = new SoundBank(audioEngine, "Content/mySoundBank.xsb");

            Font = Content.Load<SpriteFont>("SpriteFont1");
            
            screenWidth = device.PresentationParameters.BackBufferWidth;
            screenHeight = device.PresentationParameters.BackBufferHeight;
            OffsetLoop = -10;
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here
            audioEngine.Update();
           
            
            
            GameLoop();
            base.Update(gameTime);
        }
        private void GameLoop() //Gametimer_timer in original vb6
        {

            int n; int TrailTailPos;
            Random Random = new Random();
             int A = 1; int X; int y;
             if ((Paused == false) && (NowPlaying == true))
                 TickCode();
           
     
            OffsetLoop++; OffsetLoop++;
            if (OffsetLoop < 0 )
                return;
                 OffsetLoop  = -10 + Level;
                 ProcessKeyboardAndMouse();
       
       
                SpiderCode();
                SpiderCode(); //cheap way of speeding him up
            if (CurrentScore > HighScore)
                HighScore = CurrentScore;
            if (FoodOnBoard < Level * 2 + 2) PlaceFoodNuggets();
            if (TrailLength >= Level * 30 + 50) LevelUp();
            if ((Paused == false) && (NowPlaying == true))
            {
                
                //detect hitting walls
                if ((HeadPos.X == 0) || (HeadPos.Y == 0) || (HeadPos.X == 57) || (HeadPos.Y == 51))
                {
                    SpiderDeath = false;
                    GameOver();
                    return;
                }

                soundBank.PlayCue("oldstep");
                //first delete last tail pos
                TrailTailPos = TrailHeadPos - TrailLength;
                if (TrailTailPos < 1)
                    TrailTailPos += 2800;
                ItemGrid[trail[TrailTailPos].X, trail[TrailTailPos].Y] = 0;
       
                
                
                
                TrailHeadPos++;
                if (TrailHeadPos >= 2800)
                    TrailHeadPos = 1;
                trail[TrailHeadPos] = HeadPos;
                //following code is collision detection
                n = ItemGrid[HeadPos.X, HeadPos.Y];
                if (n == 0)
                { ItemGrid[HeadPos.X, HeadPos.Y] = 11;
                 // trail[TrailHeadPos]
                }
                else if ((n >= 1) && (n <= 9))
                {
                    ItemGrid[HeadPos.X, HeadPos.Y] = 11;//replace food with body
                    AddToTail += n;
                    CurrentScore = CurrentScore + (n * Level);
                    soundBank.PlayCue("Eat");

                }
                else if (n == 11)//body or wall
                {
                    SpiderDeath = false;
                    GameOver();
                }
                else if (n == 12)
                {
                    SpiderDeath = true;
                    GameOver();
                }
                if (AddToTail > 0)
                {
                    AddToTail--;
                    TrailLength++;
                }
         
            }
        }
        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            spriteBatch.Begin();
            DrawBackground();
            
            if ((TickInAction == true) && (Paused == false))
               spriteBatch.Draw(TickTexture, new Vector2(TickX - 20, TickY - 20), Color.White);
            DrawText();
            DrawWorm();
            if ((SpiderVisible == true) && (Paused == false))
               spriteBatch.Draw(SpiderTexture, new Vector2(SpiderX, SpiderY), Color.White);
            spriteBatch.End();

            
            base.Draw(gameTime);
        }
        private void DrawWorm()
        {
            int Rotation = 0; int CL; int CM; int XOffset = 0; int YOffset = 0;
            if (Paused == true) return;
            switch (trail[TrailHeadPos].Dir)
            { 
                case 1:
                    Rotation = 0;
                    YOffset = -OffsetLoop;
                    XOffset = 0;
                    break;
                case 2:
                    Rotation = 90;
                    YOffset = 0;
                    XOffset = OffsetLoop;
                    break;
                case 3:
                    Rotation = 180;
                    YOffset = OffsetLoop;
                    XOffset = 0;
                    break;
                case 4:
                    Rotation = 270;
                    YOffset = 0;
                    XOffset = -OffsetLoop;
                    break;
            }
            if (NowPlaying == false)
            {
                XOffset = 0; YOffset = 0;
            }

            spriteBatch.Draw(HeadTexture, new Rectangle(ScreenGrid[trail[TrailHeadPos].X, trail[TrailHeadPos].Y].Left - 1 + 6 + XOffset, ScreenGrid[trail[TrailHeadPos].X, trail[TrailHeadPos].Y].Top + 6 + YOffset, 12, 12), null, Color.White, MathHelper.ToRadians(Rotation), new Vector2(7, 6), 0, 0);
            for (CL = TrailHeadPos - 1; CL >= TrailHeadPos - TrailLength + 2; CL--)
            {
                CM = CL; //following code provides wrap-around of the number when it gets less than zero
                if (CM < 1)
                    CM += 2800; //trail is 2800 long
                switch (trail[CM].Dir)
                {
                case 1:
                    Rotation = 0;
                    YOffset = -OffsetLoop;
                    XOffset = 0;
                    break;
                case 2:
                    Rotation = 90;
                    YOffset = 0;
                    XOffset = OffsetLoop;
                    break;
                case 3:
                    Rotation = 180;
                    YOffset = OffsetLoop;
                    XOffset = 0;
                    break;
                case 4:
                    Rotation = 270;
                    YOffset = 0;
                    XOffset = -OffsetLoop;
                    break;
                }
                if (NowPlaying == false)
                {
                    XOffset = 0; YOffset = 0;
                }

                spriteBatch.Draw(BodyTexture, new Rectangle(ScreenGrid[trail[CM].X, trail[CM].Y].Left + 5 + XOffset, ScreenGrid[trail[CM].X, trail[CM].Y].Top + 5 + YOffset, 10, 10), null, Color.White, MathHelper.ToRadians (Rotation), new Vector2(5, 5), 0, 0);
            }
            CM = TrailHeadPos - TrailLength + 1;
            if (CM < 1)
                CM += 2800;
            if (AddToTail == 0)//tail doesn't move while growing occurs
            {
               switch (trail[CM].Dir)
               {
               case 1:
                   Rotation = 0;
                   YOffset = -OffsetLoop;
                   XOffset = 0;
                   break;
               case 2:
                   Rotation = 90;
                   YOffset = 0;
                   XOffset = OffsetLoop;
                   break;
               case 3:
                   Rotation = 180;
                   YOffset = OffsetLoop;
                   XOffset = 0;
                   break;
               case 4:
                   Rotation = 270;
                   YOffset = 0;
                   XOffset = -OffsetLoop;
                   break;
               }
           }
           else
            {
                XOffset = 0;
                YOffset = 0;
                Rotation = trail[CM].Dir * 90 - 90;
            }
            if (NowPlaying  == false)
            {
                XOffset = 0; YOffset = 0;
            }

            spriteBatch.Draw(TailTexture, new Rectangle(ScreenGrid[trail[CM].X, trail[CM].Y].Left + 5 + XOffset, ScreenGrid[trail[CM].X, trail[CM].Y].Top + 5 + YOffset, 10, 10), null, Color.White, MathHelper.ToRadians(Rotation), new Vector2(5, 5), 0, 0);
            
        }

        private void SpiderCode()
        {
    
            int x; int y; int x1; int y1;
            Random Random = new Random();
            x1 = ScreenGrid[trail[TrailHeadPos].X, trail[TrailHeadPos].Y].Left - 1; 
            y1 = ScreenGrid[trail[TrailHeadPos].X, trail[TrailHeadPos].Y].Top - 1;
            if ((SpiderVisible == true) && (SpiderAttack == false))
            {
                if (Level == 3)
                {
                    if (Random.Next(1000) == 50)
                    {
                        SpiderAttack = true;
                        soundBank.PlayCue("Heartbeat");
                    }
                }
                else if (Level > 3)
                {
                    SpiderAttack = true;
                    soundBank.PlayCue("Heartbeat");
     
                }


                if (SpiderYSpeed > -1)
                {
                    SpiderY += 2;
                    if (SpiderY >= 100)
                    {
                        SpiderYSpeed = -1;
                    }
                }
                else
                {
                    SpiderY -= 2;
                    if (SpiderY <= 50)
                    {
                        SpiderYSpeed = 1;
                    }

                }
            }
  
            if (GameEnded == true)
            {
                if (SpiderDeath == true)
                {
                    SpiderVisible = true;
                    x = trail[TrailHeadPos].X;
                    y = trail[TrailHeadPos].Y;
                    x1 = ScreenGrid[x, y].Left - 10;
                    y1 = ScreenGrid[x, y].Top - 10;
                }
            }
            else
            {
                if (SpiderAttack == true)
                {
                    if (SpiderXGoal == 0)
                    {
                        SpiderXGoal = ScreenGrid[trail[TrailHeadPos].X, trail[TrailHeadPos].Y].Left - 10; //cuz spider is 30 wide
                        SpiderYGoal = ScreenGrid[trail[TrailHeadPos].X, trail[TrailHeadPos].Y].Top - 10;
                    }
                    if ((SpiderX >= SpiderXGoal - 3) && (SpiderX <= SpiderXGoal + 3) && (SpiderY >= SpiderYGoal - Level) && (SpiderY <= SpiderYGoal + Level))
                    { 
                        SpiderXGoal = Random.Next(54) * 10;
                        SpiderYGoal = Random.Next(48) * 10;
                    }

                }
            }
            if (SpiderVisible == true)
            {
                if ((GameEnded == true) || (SpiderAttack == true))
                {
                    if (GameEnded == false)
                    {
                        x1 = SpiderXGoal;
                        y1 = SpiderYGoal;
                    }
                    if (SpiderX < x1)
                    { SpiderX++; SpiderX++; }
                    else
                        SpiderX--; SpiderX--;
                    if (SpiderY < y1)
                        SpiderY += ((Level - 3) * 2);
                    else
                        SpiderY -= ((Level - 3) * 2);

                }
                //spider collision code
                x1 = ScreenGrid[trail[TrailHeadPos].X, trail[TrailHeadPos].Y].Left - 1;
                y1 = ScreenGrid[trail[TrailHeadPos].X, trail[TrailHeadPos].Y].Top - 1;
                if ((x1 + 12 > SpiderX) && (x1 < SpiderX + 30) && (y1 + 12 > SpiderY + 5) && (y1 < SpiderY + 30) && (SpiderDeath == false))
                {
                    SpiderDeath = true;
                    GameOver();
                }
            }
        }
        private void TickCode()
        {
            
            Random Random = new Random();
            int TickItemX = 0; int TickItemY = 0; int X; int Y;
     
            if (Paused == true) return;
            if (NowPlaying == false) return;
            if (TickInAction == true)

            {
                TickY += 5;
                for (Y = 1; Y <= 49; Y++)//locate block under tick's Y axis
                {
                    if ((TickY - 10 > ScreenGrid[1, Y].Top) && (TickY - 10 < ScreenGrid[1, Y].Bottom))
                        TickItemY = Y;
                }
                for (X = 1; X <= 55; X++)
                {
                    if ((TickX - 10 > ScreenGrid[X, 1].Left) && (TickX - 10 < ScreenGrid[X, 1].Right))
                        TickItemX = X;
                }
                if ((TickItemX != 0) && (TickItemY != 0))
                {
                    if (ItemGrid[TickItemX + 1, TickItemY + 1] == 0)
                        
                        if (Random.Next(1, 10) == 6)
                        ItemGrid[TickItemX + 1, TickItemY + 1] = Random.Next(1, 9);

                }
                if (TickY >= 700)
                {
                    TickInAction = false;
                    TickY = 1;
                }
            }
            else
            {
                if ((Random.Next(1, 700) == 40) && (Level > 1))
                {
                    TickX = Random.Next(191, 800);
                    TickInAction = true;
                    soundBank.PlayCue("tick");
                }
                 
            }

        }
        private void PlaceFoodNuggets()
        {
            int x; int y;
            Random Random = new Random();
            do
            {
                x = Random.Next(1, 56);
                y = Random.Next(1, 50);
            } while (ItemGrid[x, y] != 0);
            ItemGrid[x, y] = Random.Next(1, 9);
        }

        private void Init()
        {
            SpiderDeath = false;
            SetUpScreenGrid();

        }
        private void GameOver()
        {
            SpiderAttack = false;
            GameEnded = true;
            NowPlaying = false;
            Paused = false;
            soundBank.PlayCue("crash");
        }
        private void DrawBackground()
        {
            int x; int y;
            Rectangle screenRectangle = new Rectangle(0, 0, screenWidth, screenHeight);
          
            spriteBatch.Draw(BackgroundTexture, screenRectangle, Color.White);
            
            if ((NowPlaying == true) && (Paused == true))
            {
               spriteBatch.Draw(PausedTexture, new Rectangle(191, 51, 564, 501), Color.White);
            }
            else
            {
                FoodOnBoard = 0;
                for (x = 1; x <= 56; x++)
                {
                    for (y = 1; y <= 50; y++)
                    {
                      
                        if ((ItemGrid[x, y] > 0) && (ItemGrid[x, y] < 10))
                        {
                            FoodOnBoard++;
                            spriteBatch.Draw(MushroomTexture, ScreenGrid[x, y], Color.White);
                        }
                        else if (ItemGrid[x, y] == 13)
                        {
                            spriteBatch.Draw(WebTexture, new Rectangle(ScreenGrid[x - 1, y].X, ScreenGrid[x, y - 1].Y, ScreenGrid[x, y].Width * 3, ScreenGrid[x, y].Height * 3), Color.White);
                        }
                    }
                }
                if (GameEnded == true)
                    spriteBatch.Draw(GameOverTexture, new Vector2(380, 270), Color.White);

            }

        }
        private void DrawText()
        {
            String LevelText;
            if (NowPlaying == false)
            {
                spriteBatch.DrawString(Font, "New Game", new Vector2(68, 483), Color.Yellow);
            }
            else
            {
                switch (Level)
                {
                    case 1:
                        LevelText = "you probably won't die.  If you do, you REALLY SUCK.  It gets MUCH harder later.";
                        break;
                    case 2:
                        LevelText = "mana from heaven.  Sometimes.  His aim is bad.";
                        break;
                    case 3:
                        LevelText = "Spider's hungry.  Watch out for webs or he'll get to eat.";
                        break;
                    case 4:
                        LevelText = "REALLY HUNGRY NOW.  Spider might just take matters into his own hands!";
                        break;
                    default:
                        LevelText = "you're still alive?";
                        break;
                }
            spriteBatch.DrawString(Font, "level " + Level.ToString("##") + " ... " + LevelText, new Vector2(20, 570), Color.Yellow);
   
             if(Paused == false)
                spriteBatch.DrawString(Font, "Pause", new Vector2(80, 483), Color.Yellow);
             else
                spriteBatch.DrawString(Font, "Unpause", new Vector2(74, 483), Color.Yellow);   
            }
            spriteBatch.DrawString(Font, "Quit", new Vector2(87, 527), Color.Orange );
            spriteBatch.DrawString(Font, "Score:", new Vector2(70, 130), Color.White);
            spriteBatch.DrawString(Font, "HiScore:", new Vector2(70, 180), Color.White);
            spriteBatch.DrawString(Font, "Level:", new Vector2(70, 230), Color.White);
            spriteBatch.DrawString(Font, "Next Level:", new Vector2(70, 280), Color.White);
            spriteBatch.DrawString(Font, CurrentScore.ToString("d6") , new Vector2(70, 145), Color.Yellow);
            spriteBatch.DrawString(Font, HighScore.ToString("d6"), new Vector2(70, 195), Color.Yellow);
            spriteBatch.DrawString(Font, Level.ToString("##"), new Vector2(70, 245), Color.Yellow);
            spriteBatch.DrawString(Font, (Level * 50 + 30 - TrailLength).ToString("##"), new Vector2(70, 295), Color.Yellow);
        }
        private void ProcessKeyboardAndMouse()
        {
            MouseState M = Mouse.GetState();
             NewDir = false;
            KeyboardState keybState = Keyboard.GetState();
            if (M.LeftButton.ToString() == "Pressed")
            {
                if ((M.X >= 51) && (M.X <= 151))
                {
                   if ((M.Y > 482) && (M.Y < 503))
                   {
                      soundBank.PlayCue("click");
                      if (NowPlaying == false)
                      {
                          NowPlaying = true;
                          NewGame();
                      }
                      else
                      {
                          Paused ^= true;
                      }

                   }
                }
             //   if ((M.Y 
            }




            if (Paused == false)
            {
                if ((keybState.IsKeyDown(Keys.Up)) || (GamePad.GetState(PlayerIndex.One).DPad.Up == ButtonState.Pressed))
                {
                    if ((Direction.Y != 1) && (Direction.Y != -1))
                    {
                        HeadPos.Y--;
                        Direction.Y = -1;
                        Direction.X = 0;
                        HeadPos.Dir = 1;
                        NewDir = true;

                    }

                }
                else if ((keybState.IsKeyDown(Keys.Left)) || (GamePad.GetState(PlayerIndex.One).DPad.Left == ButtonState.Pressed))
                {
                    if ((Direction.X != 1) && (Direction.X != -1))
                    {
                        HeadPos.X--;
                        Direction.X = -1;
                        Direction.Y = 0;
                        HeadPos.Dir = 4;
                        NewDir = true;

                    }
                }
                else if ((keybState.IsKeyDown(Keys.Right)) || (GamePad.GetState(PlayerIndex.One).DPad.Right == ButtonState.Pressed))
                {
                    if ((Direction.X != 1) && (Direction.X != -1))
                    {
                        HeadPos.X++;
                        Direction.X = 1;
                        Direction.Y = 0;
                        HeadPos.Dir = 2;
                        NewDir = true;
                    }

                }
                else if (keybState.IsKeyDown((Keys.Down)) || (GamePad.GetState(PlayerIndex.One).DPad.Down == ButtonState.Pressed))
                {
                    if ((Direction.Y != 1) && (Direction.Y != -1))
                    {
                        HeadPos.Y++;
                        Direction.Y = 1;
                        Direction.X = 0;
                        HeadPos.Dir = 3;
                        NewDir = true;
                    }
                }
                else if ((keybState.IsKeyDown(Keys.N)) || (GamePad.GetState(PlayerIndex.One).Buttons.Start  == ButtonState.Pressed))
                {
                    if (NowPlaying == false)
                    {
                        NowPlaying = true;
                        NewGame();
                    }
                }

                if ((keybState.IsKeyDown(Keys.P)) || (GamePad.GetState(PlayerIndex.One).Buttons.A == ButtonState.Pressed))
                    Paused = true;


            }
            else
            {
                if ((keybState.IsKeyDown(Keys.U)) || (GamePad.GetState(PlayerIndex.One).Buttons.B == ButtonState.Pressed))
                    Paused = false;

            }
            if ((NewDir == false) && (Paused == false) && (NowPlaying == true))
            {
                HeadPos.X += Direction.X;
                HeadPos.Y += Direction.Y;
            }
    
        }    
            //code checks for out-of-bounds
            
        
        private void NewGame()
        {
            SpiderAttack = false;
            SpiderVisible = false;
            SpiderX = 10;
            SpiderY = 10;
            GameEnded = false;
            int x; int y;
            for (x = 1; x <= 56; x++)
            {
                for (y = 1; y <= 50; y++)
                {
                    ItemGrid[x, y] = 0;
                }
            }
            TrailLength = 3;
            TrailHeadPos = 3;
            HeadPos.X = 28;
            HeadPos.Y = 25;
            HeadPos.Dir = 2;
            trail[3] = HeadPos;
            trail[2] = trail[3];
            trail[2].X--;
            trail[1] = trail[2];
            trail[1].X--;
            Direction.X = 1;
            Direction.Y = 0;
            CurrentScore = 0;
            Level = 1;
        }
        private void LevelUp()
        {
            int x; int y; int cl; int x2; int y2;
            for (x = 1; x <= 56; x++)
            {
                for (y = 1; y <= 50; y++)
                {
                    ItemGrid[x, y] = 0;
                }
            }
            TrailLength = 3;
            TrailHeadPos = 3;
            HeadPos.X = 28;
            HeadPos.Y = 25;
            HeadPos.Dir = 2;
            trail[3] = HeadPos;
            trail[2] = trail[3];
            trail[2].X--;
            trail[1] = trail[2];
            trail[1].X--;
            Direction.X = 1;
            Direction.Y = 0;
            
            Level++;
            if (Level > 2)
            {
               Random Random = new Random();
                SpiderVisible = true;
                for (cl = 1; cl <= Level; cl++)
                { 
                   do
                   {
                      x = Random.Next(1, 53) + 2;//buffer because web takes up 9 squares
                      y = Random.Next(1, 48) + 2;
                  
                   } while (!((ItemGrid[x, y] == 0) && (x != 28) && (x != 27) && (x != 29)));//no web on starting squares!
                   for (x2 = -1; x2 <= 1; x2++)//mark item grid as having web in this location
                   {
                      for (y2 = -1; y2 <= 1; y2++)
                      {
                         ItemGrid[x + x2, y + y2] = 12;
                         ItemGrid[x, y] = 13; //13 is web center for drawing purposes
                      }
                   }
                }

            }
   
        }
    }
}
